-- Start Word with empty document
Word = .OLEObject~New("Word.Application")
Word~Visible = .TRUE                    -- make Word visible
Document = Word~Documents~Add           -- add document
Selection = Word~Selection              -- selection object
Selection~Font~Size = "32"              -- change font size

-- Check text encoding
textEncoding=Document~textEncoding      -- get Word's encoding
say "textEncoding is:" textEncoding

OutText = 'Wer nämlich mit "h" schreibt, ist dämlich.' -- UTF-8 encoded

say "1. Output to Word without changing the encoding..."
Selection~TypeText(OutText)             -- give selection a text
Selection~TypeParagraph                 -- add paragraph (go to next line)

fromCp="UTF8"                           -- text is UTF-8 encoded
if textEncoding=65001 then toCp="UTF-8"
                      else toCp="Cp"textEncoding
say "source text encoding:" fromCp "to:" toCp
OutText = bsf.iconv(outText, "UTF-8",toCp)   -- use BSF4ooRexx to convert text

say "2. Output to Word after changing the encoding...."
Selection~TypeText(OutText)             -- give selection a text
Selection~TypeParagraph                 -- add paragraph (go to next line)

::requires "BSF.CLS"                    -- get ooRexx-Java bridge
