/* ---rgf, 2002-12 */
   oleobj = .OleObject~New("RxAgent.AnAgent")
   german    ="&H0407"
   br_english="&H0809"
   english   ="&H0409"
   italian   ="&H0410"
   french    ="&H040C"
   spanish   ="&H0C0A"

      /* define a set of character arrays, where each array object
                defines a character, a language and a sentence to be spoken */
   o=.list~of(  .array~of("Genie",  german,     '\map="Meine liebe Alies, ich liebe Dich!"="Meine liebe Alice, ich liebe Dich!"\'), ,
               .array~of("Merlin", english,    "My dearest Alice, I love you!")     , ,
               .array~of("Robby",  br_english, "My dearest Alice, I love you!")     , ,
               .array~of("Genie",  french,     "Ma chre Alice, je t'aime!")        , ,
               .array~of("Merlin", spanish,    "Mi Alicia querida, te amo!")       , ,
               .array~of("Peedy",  italian,    "Mia cara Alice, ti amo!") )

   announcer=.oleobject~new("RxAgent.AnAgent")  -- create instance
   announcer~load("", "Merlin", 0, 0)        -- load the Merlin character
   announcer~setLID("Merlin", english)       -- make sure character speaks English
   oleobj=.oleobject~new("RxAgent.AnAgent")  -- create instance
   tmpSet=.set~new

   do bDifferentAgents over .list~of(.false, .true)-- iterate two times,
      announcer~moveTo(0, 0)
      announcer~speak( "[ANN:] In this round" choose(bDifferentAgents, "", "[no]") "separate agents will be used! langid:" announcer~getLID("Merlin"))
      do a over o          -- iterate over all of the character arrays in the list
         x=random(0,900)               -- choose random x-co-ordinate
         y=random(0,600)               -- choose random y-co-ordinate
         if tmpSet~hasindex(a[1]) then
         do
say "char:" a[1]
             oleobj~unload(a[1])
             tmpSet~remove(a[1])
         end
         oleobj~load("", a[1], x, y)   -- load the character
         tmpSet~put(a[1])

         oleobj~setLID(a[1], a[2])
         oleobj~speak(a[3])
   --      oleobj~unload(a[1])
         if bDifferentAgents then      -- do you wish to create separate agent instances?
         do
            oleobj=.OleObject~new("RxAgent.AnAgent")  -- eine eigene Instanz eines Agenten
say "a new oleobj got created ! "
         end
      end
   end

::routine choose
   if arg(1)=.true then return arg(2)
                   else return arg(3)
