/* ---rgf, 2004-10 */

-- If using mulitple inheritance with metaclasses, it seems that the method resolution is
-- not set up correctly

say center(" start of program ", 78, "=")
-- .testCS~~new~~new~~new -- create three instances
say "created object:" .testCS~new~"=="~c2x
say "----------"
say "created object:" .testCS~new~"=="~c2x
say "----------"
say "created object:" .testCS~new~"=="~c2x
say "----------"
say pp(.testCS) "number of objects created:" .testCS~counter
say copies("-", 78)
say

-- .testSC~~new~~new~~new -- create three instances
say "created object:" .testSC~new~"=="~c2x
say "----------"
say "created object:" .testSC~new~"=="~c2x
say "----------"
say "created object:" .testSC~new~"=="~c2x
say "----------"
say pp(.testSC) "number of objects created:" .testSC~counter
say "---"
say


::routine pp
  return "[" || arg(1)~string || "]"

::class testCS METACLASS counter_singleton
::class testSC METACLASS singleton_counter



  ::CLASS Singleton MIXINCLASS Class

  ::METHOD Init
    EXPOSE SingleInstance
    SingleInstance = .nil
    say "Singleton:" "init()..."   "self="pp(self) "super="pp(super)
    self~init:super

  ::METHOD New
    EXPOSE SingleInstance
    IF SingleInstance = .nil THEN
    DO
       say "Singleton:" "new()..."   "self="pp(self) "super="pp(super) "creating object!"
       FORWARD CLASS (super) CONTINUE
       SingleInstance = RESULT
    END
    self~rgfTest
    say "Singleton:" "new()..."   "self="pp(self) "super="pp(super)
    RETURN SingleInstance

  ::method rgfTest
    say "Singleton:" "rgfTest()..."   "self="pp(self) "super="pp(super)
    if super~hasmethod("rgfTest") then
    do
       say "Singleton: forwarding to"  "self="pp(self) "super="pp(super)
       forward class (super)
    end



::CLASS  Counter   MIXINCLASS Class

::METHOD Init
  self~Counter = 0
  say "Counter:" "init()..."  "self="pp(self) "super="pp(super)
  self~init:super

::METHOD Counter  ATTRIBUTE

::METHOD New
  EXPOSE Counter
  say "Counter:" "new()..."  "self="pp(self) "super="pp(super)
  Counter = Counter + 1
  self~rgfTest
  FORWARD CLASS (super)

  ::method rgfTest

    say "Counter:" "rgfTest()..."   "self="pp(self) "super="pp(super)
    if super~hasmethod("rgfTest") then
    do
       say "Counter: forwarding to"  "self="pp(self) "super="pp(super)
       forward class (super)
    end




::CLASS Singleton_Counter    MIXINCLASS Singleton INHERIT Counter
::CLASS Counter_Singleton    MIXINCLASS Counter   INHERIT Singleton


