/* Multiple Inheritance */
.RoadVehicle      ~new("Truck")   ~drive
.WaterVehicle     ~new("Boat")    ~swim
.AmphibianVehicle ~new("SwimCar") ~~hi ~show_off


::CLASS     Vehicle
::ATTRIBUTE name
::METHOD    INIT
  self~name = ARG(1)
::METHOD    tsk
  SAY self~name": 'tsk!'"

::method  hi
  say 'Vehicle:hi'

::CLASS     RoadVehicle  MIXINCLASS Vehicle
::METHOD    drive
  SAY self~name": 'I drive now...'"
::method  hi
  say 'RoadVehicle:hi, ... now doing a "self~hi:super"'
  self~hi:super

::CLASS     WaterVehicle MIXINCLASS Vehicle
::METHOD    swim
  SAY self~name": 'I swim now...'"
::method  hi
  say 'WaterVehicle:hi, ... now doing a "self~hi:super"'
  self~hi:super

::CLASS     AmphibianVehicle SUBCLASS RoadVehicle INHERIT WaterVehicle
::METHOD    show_off
  self ~~drive ~~swim ~~tsk
::method  hi
  say 'AmphibianVehicle:hi, ... now doing a "self~hi:super"'
  self~hi:super
