/* myfilter2.rex: if value contains 'r' then write it to stdout, else to stderr */
signal on notready      -- raised, if no input data anymore
do forever              -- loop eternally, same as: loop
   parse linein value   -- get line from stdin, raises notready if no data anymore
   if pos('r',value)>0 then .output~say(value)  -- write value to stdout
                       else .error ~say(value)  -- write value to stderr
end
notready:               -- label to signal, if no input anymore
