  Outlook = .OLEObject~new("Outlook.Application")
  NameSpace = Outlook~GetNamespace("MAPI")

  -- In Outlook folder have numbers:
  -- DeletedItems (3), Outbox (4), SentMail (5), Inbox (6),
  -- Calendar (9), Contacts (10), Journal (11), Notes (12),
  -- Tasks (13)
  Inbox = NameSpace~GetDefaultFolder("6")      -- selects Inbox

  -- makes Outlook visible and shows Inbox
  Inbox~Display

  InboxItems = Inbox~Items
  MailCount = InboxItems~Count                      -- count items in Inbox
  say "You have" MailCount "Mail(s) in your Inbox:"

  Do ItemNumber = 1 to MailCount                    -- go through each item
    Item = Inbox~Items(ItemNumber)
    Sender = Item~Sender~Name                       -- sender of item
    say "#" ItemNumber"." Sender
  end
