/* */
a=.x~new
b=.x~new
c=.x~new
fifo=.fifo~new     /* FIFO-instance */
.local~repetitions = 500
a~testwrite(fifo, "from_a")
b~testwrite(fifo, "FROM_B")
c~testread(fifo)
say "after testread"

::class X
::method testwrite
  use arg fifo, msg1
  REPLY
  do i=1 to .repetitions
    fifo~write(msg1 i)
  end
::method testread
  use arg fifo
  REPLY
  do while fifo~items > 0
    i=fifo~read
    say i
  end

::class FIFO
::method init
  expose buffer lock
  buffer=.queue~new
  lock=.false
::method write UNGUARDED
  expose buffer lock
  GUARD ON WHEN lock=.false
  lock=.true
  GUARD OFF
  use arg tmp
  buffer~queue(tmp)     /* queue item */
  GUARD ON
  lock=.false
::method read  UNGUARDED
  expose buffer lock
  GUARD ON WHEN lock=.false
  lock=.true; GUARD OFF
  data=buffer~pull      /* get item   */
  GUARD ON; lock=.false
  return data
::method items
  expose buffer
  return buffer~items