signal on any
   call test_speech2
   exit

pp: return "[" || arg(1) || "]"

any:
   d=condition("O")  -- get the exception object (a directory object)

   do index over d   -- iterates over the directory object
        /* show index and associated/stored item */
      say "--->" pp(index)~right(14)":" pp(d~at(index))
   end
   say

   say "Additional:" -- show additional exception information
   a=d~additional    -- get the entry with index "ADDITIONAL" (an array-object)
   do item over a    -- iterates over array object
      say "   " pp(item)  -- show stored item
   end
   say

   say "Traceback:"  -- show the traceback (list of Rexx statements)
   l=d~traceback     -- get the entry with index "TRACEBACK" (a list-object)
   do item over l    -- iterates over list object
      say "   " pp(item)  -- show stored item
   end
   exit -1
