/* ag_play_wav.rex, Lee Pedin as of: 2003-01-14, ---rgf just changed filespec part */
'cls'
   char1 = "Merlin"
   oleobj1 = .OleObject~New("Agent.Control.1")
   oleobj1~Connected = .True
   oleobj1~Characters~Load(char1, char1".acs")
   mychar1 = oleobj1~Characters(char1)
   mychar1~Top = 50
   mychar1~Left = 50
   mychar1~LanguageID = x2d(409)
   objstatus = mychar1~Show
   call CkStatus

   -- filespec = "c:\program files\objrexx\oodialog\samples\wav\phil*.wav"
   -- filespec on rgf's German machine: D:\Programme\ObjREXX

   -- look for path to Object Rexx (could be anywhere!)
   path=value("PATH",,"ENVIRONMENT")      -- get value of environment variable "PATH"
   needle="\objrexx"                      -- define needle to look for
   parse caseless var path path (needle)  -- use caseless parse to find needle, build filespec
   filespec=substr(path, lastpos(":", path)-1) || needle || "\oodialog\samples\wav\phil*.wav"

   call SysFileTree filespec, "philwav", "F"
   do i = 1 to philwav.0
     wavfile = ""
     do aa = 5 to words(philwav.i)
       wavfile = wavfile||word(philwav.i,aa)' '
     end
     wavfile = strip(wavfile,'b',' ')

     select
       when i = 1 then
         do
           say 'No Balloon'
           objStatus = mychar1~Show
           objStatus = mychar1~Speak(,wavfile)
           call CkStatus
         end
       when i = 2 then
         do
           btext = 'Other Text In Balloon'
           say btext
           objStatus = mychar1~Speak(btext,wavfile)
           call CkStatus
         end
       when i = 3 then
         do
           say "Name of wav file - note \'s have been stripped"
           objStatus = mychar1~Speak(wavfile,wavfile)
           call CkStatus
         end
       otherwise
         do
           say 'Show just the file name'
           btext = substr(wavfile,lastpos("\",wavfile)+1)   -- Just show the file name
           objStatus = mychar1~Speak(btext,wavfile)
           call CkStatus
         end
     end
   end
exit

CkStatus:
   Do Until objStatus~Status = 0
      call SysSleep(1)
   end
return
