/* ---rgf, 2002-12 */
   oleobj = .OleObject~New("RxAgent.AnAgent")
   german    ="&H0407"
   br_english="&H0809"
   english   ="&H0409"
   italian   ="&H0410"
   french    ="&H040C"
   spanish   ="&H0C0A"

      /* define a set of character arrays, where each array object
                defines a character, a language and a sentence to be spoken */
   o=.set~of(  .array~of("Genie",  german,     '\map="Meine liebe Alies, ich liebe Dich!"="Meine liebe Alice, ich liebe Dich!"\'), ,
               .array~of("Merlin", english,    "My dearest Alice, I love you!")     , ,
               .array~of("Robby",  br_english, "My dearest Alice, I love you!")     , ,
               .array~of("Genie",  french,     "Ma chre Alice, je t'aime!")        , ,
               .array~of("Merlin", spanish,    "Mi Alicia querida, te amo!")       , ,
               .array~of("Peedy",  italian,    "Mia cara Alice, ti amo!") )
   cSet=.set~new

   do a over o          -- iterate over all of the character array-objects in the set
      x=random(0,800)               -- choose random x-co-ordinate
      y=random(0,600)               -- choose random y-co-ordinate
      if cSet~hasindex(a[1]) then
      do
          oleobj~unload(a[1])
          cSet~remove(a[1])
      end
      oleobj~load("", a[1], x, y)   -- load the character for the agent
      cSet~put(a[1])
      oleobj~setLID(a[1], a[2])     -- set the language of the character
      oleobj~speak(a[3])            -- speak the text
   end

call sysSleep 5   -- wait 3 seconds
say "it's over now..."

